<!DOCTYPE html>
<html>
    <head>
        <title>Lucky Dice branch develop</title>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
        <style>
            .bg-img {
                background-image: url("images/cover.jpg");
                min-height: 100px; 
                margin: 5px;
            }
        </style>
    </head>
    <body>
        <div class="container-fluid">
            <div class="bg-img"></div>
        </div>
        <div class="container">
            <div class="row">
                <div class="col-md-4">
                    <div class="row form-group">
                        <div class="col-md-12 ">
                            <h4>Nhập thông tin của bạn</h4>
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-md-4">
                            <label for="username">Username</label>
                        </div>
                        <div class="col-md-8">
                            <input type="text" class="form-control" name="username" id="username">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-md-4">
                            <label for="firstname">Firstname</label>
                        </div>
                        <div class="col-md-8">
                            <input type="text" class="form-control" name="firstname" id="firstname">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-md-4">
                            <label for="lastname">Lastname</label>
                        </div>
                        <div class="col-md-8">
                            <input type="text" class="form-control" name="lastname" id="lastname">
                        </div>
                    </div>
                </div>
                <div class="col-md-4 text-center">
                    <div class="row form-group">
                        <div class="col-md-12">
                            <button onclick="onBtnThrowDiceClick()" class="btn btn-success button-width w-75">Ném</button>
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-md-12">
                            <img id="img-dice" class="img-thumbnail" src="images/dice.png" alt="Dice">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-md-12">
                            <p id="p-message"></p>
                        </div>
                    </div>
                </div>
                <div class="col-md-4 text-center">
                    <div class="row form-group">
                        <div class="col-md-12">
                            <p id="p-voucher">Voucher</p>
                            <p id="p-voucher-code">No ID</p>
                            <p id="p-voucher-percent">0%</p>
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-md-12">
                            <img id="img-present" src="images/no-present.jpg" class="img-thumbnail" alt="" width="70%" height="100%">
                        </div>
                    </div>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-md-12 text-center">
                    <button class="btn btn-success" onclick="onBtnDiceHistoryClick()">Dice History</button>
                    <button class="btn btn-info">Voucher History</button>
                    <button class="btn btn-info">Present History</button>
                </div>
            </div>
            <div class="row">
                <div class="col-md-12">
                    <table id="table-history" class="table table-striped table-hover">
                        <thead>
                            <th>Lượt</th>
                            <th>Dice</th>
                        </thead>
                        <tbody id="tbody-history">
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </body>
    <script>
        // Create const
        const gBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
        const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

        // Create user obj
        var gUserObj = {
            firstname: "",
            lastname: "",
            username: ""
        }

        // Access input element
        var gUserName = document.getElementById("username");
        var gFirstName = document.getElementById("firstname");
        var gLastName = document.getElementById("lastname");

        // Access p,img element
        var gPMessage = document.getElementById("p-message");
        var gImgDice = document.getElementById("img-dice");
        var gPVoucher = document.getElementById("p-voucher");
        var gPVoucherCode = document.getElementById("p-voucher-code");
        var gPVoucherPercent = document.getElementById("p-voucher-percent");
        var gImgPresent = document.getElementById("img-present");

        //Access table
        var gTableHistory = document.getElementById("table-history");
        var gTableHistoryBody = document.getElementById("tbody-history");
        const gEND_OF_ROW_COL = -1;
        const gCOL_COUNT_PLAY = 0;
        const gCOL_RESULT_DICE = 1;
        
        function onBtnThrowDiceClick() {
            // Get input value, pour data into user_obj
            gUserObj.firstname = gUserName.value;
            gUserObj.lastname = gFirstName.value;
            gUserObj.username = gLastName.value;
            
            var vCheck = validateData(gUserObj.username, gUserObj.firstname, gUserObj.lastname);
            if(vCheck) {
                var vXmlHttpDice = new XMLHttpRequest();
                getNewDiceThrow(vXmlHttpDice, gUserObj);
                vXmlHttpDice.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        //Gọi server lấy responseText ghi ra console.log
                        console.log(vXmlHttpDice.responseText);
                        var vResultObj = JSON.parse(vXmlHttpDice.responseText);
                        //Chuyển thành Objects và ghi dữ liệu của object  ra console.log
                        console.log(vResultObj);
                        //Call function show dice, message, voucher, prize
                        showResultAfterThrow(vResultObj);
                    }
                }
            }
        }

        //Get dice history
        function onBtnDiceHistoryClick() {
            console.log("Nút Dice History được ấn");
            // Get input value, pour data into user_obj
            gUserObj.firstname = gUserName.value;
            gUserObj.lastname = gFirstName.value;
            gUserObj.username = gLastName.value;
            
            var vCheck = validateData(gUserObj.username, gUserObj.firstname, gUserObj.lastname);
            if(vCheck) {
                var vXmlHttpDiceHistory = new XMLHttpRequest();
                getDiceHistory(vXmlHttpDiceHistory, gUserObj.username);
                vXmlHttpDiceHistory.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        console.log(vXmlHttpDiceHistory.responseText);
                        var vDiceHistoryObj =JSON.parse(vXmlHttpDiceHistory.responseText);
                        console.log("Chuyển responseText thành object, ghi ra console.log nội dung object");
                        console.log(vDiceHistoryObj);
                        deleteTable(gTableHistory);
                        createTableHistory(vDiceHistoryObj, gTableHistory);
                    }
                }
            }
        }

        // Validate data
        function validateData(paramUserName, paramFirstName, paramLastName) {
            var vResult = false;
            if(paramUserName.trim() == "") {
                alert("Chưa nhập username!");
            } else if(paramFirstName.trim() == "") {
                alert("Chưa nhập firstname!");
            } else if(paramLastName.trim() == "") {
                alert("Chưa nhập lastname!");
            } else {
                vResult = true;
            }
            return vResult;
        }

        // Call API getNewDice
        function getNewDiceThrow(paramXMLHttpDice, paramUserObj) {
            paramXMLHttpDice.open("POST", gBASE_URL + "/dice", true);
            paramXMLHttpDice.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
            paramXMLHttpDice.send(JSON.stringify(paramUserObj));  //chuyển Json object sang string
        }

        // Call API getDiceHistory
        function getDiceHistory(paramXMLHttpDiceHistory, paramUserName) {
            paramXMLHttpDiceHistory.open("GET", gBASE_URL + "/dice-history?username=" + paramUserName, true);
            paramXMLHttpDiceHistory.send();
        }

        // Show Dice, message, voucher, prize
        function showResultAfterThrow(paramResultObj) {
            gPMessage.innerHTML = "";
            // change image of dice
            gImgDice.src = "images/" + paramResultObj.dice + ".png";

            // Dice > 4 => congrate msg, else try again next time msg
            if(paramResultObj.dice < 4) {
                gPMessage.innerHTML = "Chúc bạn may mắn lần sau !!!";
            } else {
                gPMessage.innerHTML = "Chúc mừng bạn hãy chơi tiếp lần nữa !!!";
            }

            //Show voucher if have
            if(paramResultObj.voucher == null) {
                gPVoucherCode.innerHTML = "";
                gPVoucherPercent.innerHTML = "";
            } else {
                gPVoucherCode.innerHTML = paramResultObj.voucher.maVoucher;
                gPVoucherPercent.innerHTML = paramResultObj.voucher.phanTramGiamGia + "%";
            }

            //Show prize if have
            if(paramResultObj.prize != null) {
                var vImgPrize = "";
                if(paramResultObj.prize == "Mũ") {
                    vImgPrize = "hat";
                } else if(paramResultObj.prize == "Áo") {
                    vImgPrize = "t-shirt";
                } else if(paramResultObj.prize == "Xe máy") {
                    vImgPrize = "xe-may";
                } else if(paramResultObj.prize == "Ô tô") {
                    vImgPrize = "car";
                }
                gImgPresent.src = "images/" + vImgPrize + ".jpg";
            }
        }

        // Delete table function
        function deleteTable(paramTableHistory) {
            paramTableHistory.deleteTHead();
            var vRows = paramTableHistory.rows;
            for(var bI = vRows.length - 1; bI >= 0; bI--) {
                paramTableHistory.deleteRow(bI);
            }
        }

        // Create new thead and tbody
        function createTableHistory(paramHistory, paramTableHistory) {
            // create new table head
            var vTHead = paramTableHistory.createTHead();
            var vCountCell = document.createElement('th');
            var vResultCell = document.createElement('th');
            vCountCell.innerHTML = "Lượt";
            vResultCell.innerHTML = "Kết quả";
            vTHead.appendChild(vCountCell);
            vTHead.appendChild(vResultCell);

            // Add data to table body
            // Loop data
            for(var bI = 0; bI < paramHistory.dices.length; bI++) {
                //Add new row
                var bNewRow = gTableHistoryBody.insertRow(gEND_OF_ROW_COL);

                //Add new cell
                var bCountCell = bNewRow.insertCell(gCOL_COUNT_PLAY);
                var bResultCell = bNewRow.insertCell(gCOL_RESULT_DICE);

                // Add data into cell
                bCountCell.innerHTML = bI + 1;
                bResultCell.innerHTML = paramHistory.dices[bI];
            }
        }
    </script>
</html>